<template>
<div>
    <app-layout>
        <template #header>Organization: {{ organization.name }}</template>
        <div class="grid grid-cols-2 gap-2">
            <panel class="col-span-2">
                <div class="p-6 sm:px-20">
                    <h3 class="font-bold text-xl">Details</h3><!-- TODO: Multiple Domains for org -->
                    Domain: {{ organization.domain || 'No Domain Set'}}<br>
                    Features Enabled:<br>
                    <input type="checkbox" :checked="organization.features.includes('inventory')" @click.prevent="toggleFeature('inventory')" v-show="!this.featuresInProgress.includes('inventory')">
                    <fa-icon icon="spinner" class="animate-spin" v-if="this.featuresInProgress.includes('inventory')" />
                    Inventory
                    <br>
                    <input type="checkbox" :checked="organization.features.includes('displayManagement')" @click.prevent="toggleFeature('displayManagement')" v-show="!this.featuresInProgress.includes('displayManagement')">
                    <fa-icon icon="spinner" class="animate-spin" v-if="this.featuresInProgress.includes('displayManagement')" />
                    Display Management
                    <span class="text-sm">(Only managers can manage displays for the organization)</span>
                </div>
            </panel>
            <searchable-data-card
                v-if="hasPermission(['read-anything','read-groups','group:'+organization.id+':read-groups'])"
                name="Groups"
                type="groups"
                :form="groupform"
                :data="organization.children"
                :headers="{name:'Name'}"
                :parent="organization.id"
                @new="newGroupModalOpener()"
                @click="groupSelected"
            />
            <searchable-data-card
                v-if="hasPermission(['read-anything','read-users','group:'+organization.id+':read-users'])"
                name="Users"
                type="users"
                action="add"
                :form="userform"
                :data="organization.users"
                :headers="{name:'Name',email:'Email'}"
                :parent="'organization/' + organization.id"
                @new="newUserModalOpen = true"
                @click="userSelected"
            />
        </div>
    </app-layout>
    <dialog-modal :show="newGroupModalOpen" @close="newGroupModalOpen = false">
        <template #title>New Group</template>
        <div class="mb-4">
            <x-label class="block text-gray-700 text-sm font-bold mb-2">Name</x-label>
            <x-input v-model="groupform.name" placeholder="My Group" class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"/>
        </div>
        <template #footer>
            <danger-button @click.native.prevent="newGroupModalOpen = false">Cancel</danger-button>
            <x-button class="ml-2" @click.native.prevent="createGroup">Create</x-button>
        </template>
    </dialog-modal>
    <dialog-modal :show="newUserModalOpen" @close="newUserModalOpen = false">
        <template #title>Add Users to {{organization.name}}</template>
        <div class="mb-4">
            <x-label class="block text-gray-700 text-sm font-bold mb-2">Emails</x-label>
            <x-input v-model="userform.emails" placeholder="example@example.org;example2@example.net" class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"/>
            <div class="block text-gray-600 text-sm mt-1">Please separate emails by a space, comma, or semicolon</div>
        </div>
        <template #footer>
            <danger-button @click.native.prevent="newUserModalOpen = false">Cancel</danger-button>
            <x-button class="ml-2" @click.native.prevent="addUsers">Add</x-button>
        </template>
    </dialog-modal>
    <dialog-modal :show="userModalOpen" @close="userModalOpen = false">
        <template #title>Roles for {{ currentUser.name }}</template>
        <div>
            <div v-for="role in currentUserRoles" :key="role.id">
                {{ role.name }}
            </div>
            <div v-if="currentUserRoles.length === 0" class="text-sm">
                No Roles are assigned to this user for this group
            </div>
            <select multiple>
                <option v-for="role in roles" :key="role.id" :value="role.id" class="dark:bg-gray-800">{{ role.name }}</option>
            </select>
        </div>
        <template #footer>
            <danger-button @click.native.prevent="removeUser">Remove from Organization</danger-button>
            <danger-button class="ml-2" @click.native.prevent="userModalOpen = false">Cancel</danger-button>
            <x-button class="ml-2" @click.native.prevent="">Update</x-button>
        </template>
    </dialog-modal>
</div>
</template>

<script>
    import SearchableDataCard from './../../Components/SearchableDataCard'

    export default {
        components: {
            SearchableDataCard
        },
        props: {
            organization: {
                type: Object,
                required: true,
            },
            roles: {
                type: Array,
            }
        },
        data(){
            return {
                groupform: this.$inertia.form({
                    name: this.name,
                }, {
                    bag: 'newGroup',
                    resetOnSuccess: true,
                }),
                userform: this.$inertia.form({
                    emails: this.emails,
                }, {
                    bag: 'addUser',
                    resetOnSuccess: true,
                }),
                newUserModalOpen: false,
                newGroupModalOpen: false,
                userModalOpen: false,
                featuresInProgress: [],
                selectedUser: {},
            }
        },
        computed: {
            currentUser(){
                if(this.selectedUser === null) return {};
                for(const user of this.organization.users){
                    if(user.id == this.selectedUser) return user;
                }
                return {};
            },
            currentUserRoles(){
                if(this.selectedUser === null || this.currentUser.roles === undefined) return [];
                const roles = [];
                for(const role of this.currentUser.roles){
                    if(role.group_id == this.organization.id) roles.push(role);
                }
                return roles;
            }
        },
        methods:{
            newGroupModalOpener(id = null){
                this.newGroupModalOpen = true;
                this.groupform.parent = id;
            },
            createGroup(){
                this.newGroupModalOpen = false;
                this.groupform.post('/organizations/'+this.organization.id+'/group',{
                    preserveScroll: true,
                });
            },
            addUsers(){
                this.newUserModalOpen = false;
                this.userform.post('/organizations/'+this.organization.id+'/users',{
                    preserveScroll: true,
                });
            },
            toggleFeature(feature){
                this.featuresInProgress.push(feature);
                if(this.featuresInProgress.length == 1) this.postToggleFeature(feature);
            },
            postToggleFeature(feature){
                console.log("Posting toggle feature",feature);
                this.$inertia.put('/organizations/'+this.organization.id+'/feature',{
                    feature,
                },{
                    preserveScroll: true,
                    only: ['organization'],
                    onSuccess: page => {
                        this.featuresInProgress.splice(this.featuresInProgress.indexOf(feature),1);
                        if(this.featuresInProgress.length > 0) {
                            this.postToggleFeature(this.featuresInProgress[0]);
                        }
                    },
                });
            },
            groupSelected(id){
                this.$inertia.get('/groups/'+id);
            },
            userSelected(id){
                this.selectedUser = id;
                this.userModalOpen = true;
            },
            removeUser(){
                if(this.selectedUser && confirm('Are you sure you want to remove this user from this organization?')){
                    this.$inertia.delete('/organizations/' + this.organization.id + '/users/' + this.selectedUser);
                } else {
                    this.selectedUser = null;
                }
            }
        }
    }
</script>